#ifndef _CMEMPOOL_H
#define _CMEMPOOL_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define _DEBUG_MEMPOOL 1

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

typedef struct _TAG_ALLOC_POOL {
	int iAddress;
	bool bFree;
} ALLOCPOOL, *LPALLOCPOOL;

typedef struct _TAG_USER_ALLOC {
	ALLOCPOOL *AllocPool;

	int iAllocated;
	int iAllocIncrement;
} USERALLOC, *LPUSERALLOC;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

class CMemoryPool{

	public:
		void *Allocate(const int iSize, const int iCount);
		void *ReAllocate(void *lpMemory, const int iSize);
		bool Free(void *lpMemory);
		bool FreeAll(void);
		bool Init(void);
		bool Destroy(void);
		int GetMemAllocationCount(void);
		int GetSlotAllocationCount(void);
		int DumpMemFile(void);

	protected:
		int FindFreeAllocSlot(void);
		int GetSlotByAddress(int iAddress);

	private:
		USERALLOC UserAlloc;
		int iUserAllocs;

		CRITICAL_SECTION csMemLock;
};

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

extern CMemoryPool gMem;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
